--- old/usr/src/cmd/dis/dis_target.c	2013-08-17 17:56:51.833663745 -0400
+++ new/usr/src/cmd/dis/dis_target.c	2013-08-17 17:56:51.844734264 -0400
@@ -643,9 +643,13 @@
 	    addr >= tgt->dt_symcache->se_sym.st_value &&
 	    addr < tgt->dt_symcache->se_sym.st_value +
 	    tgt->dt_symcache->se_sym.st_size) {
-		*offset = addr - tgt->dt_symcache->se_sym.st_value;
-		*size = tgt->dt_symcache->se_sym.st_size;
-		return (tgt->dt_symcache->se_name);
+		sym = tgt->dt_symcache;
+		*offset = addr - sym->se_sym.st_value;
+		*size = sym->se_sym.st_size;
+		if (isfunc != NULL)
+			*isfunc = (GELF_ST_TYPE(sym->se_sym.st_info) ==
+			    STT_FUNC);
+		return (sym->se_name);
 	}
 
 	lo = 0;
